package stundentafel_cnf;

/**
 * @author Benjamin A. Bartsch
 */
public class D_Schueler implements Comparable<D_Schueler> {

    final int id;
    final String name;
    final String vorname;
    final String gebDat;
    final String geschlecht;
    final String db_idnr;

    D_Schueler(int id, String pName, String pVorname, String pGebDat, String pGeschlecht, String db_idnr) {
        this.id = id;
        this.name = pName;
        this.vorname = pVorname;
        this.gebDat = pGebDat;
        this.geschlecht = pGeschlecht;
        this.db_idnr = db_idnr;
    }

    // dummy constructor
    D_Schueler(String pName, String pVorname, String pGebDat, String pGeschlecht) {
        this.id = -1;
        this.name = pName;
        this.vorname = pVorname;
        this.gebDat = pGebDat;
        this.geschlecht = pGeschlecht;
        this.db_idnr = "";
    }
    
    @Override
    public String toString() {
        return name + ", " + vorname + ", "+gebDat+", "+geschlecht+" [db="+db_idnr+"]";
    }

    @Override
    public int compareTo(D_Schueler o) {
        if (compareNoID(o) != 0) return compareNoID(o);
        return new Integer(id).compareTo(o.id);
    }

    int compareNoID(D_Schueler o) {
        if (name.compareTo(o.name) != 0) return name.compareTo(o.name);
        if (vorname.compareTo(o.vorname) != 0) return vorname.compareTo(o.vorname);
        if (gebDat.compareTo(o.gebDat) != 0) return gebDat.compareTo(o.gebDat);
        if (geschlecht.compareTo(o.geschlecht) != 0) return geschlecht.compareTo(o.geschlecht);
        return 0;
    }

}
