package stundentafel_cnf;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;
import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.border.TitledBorder;
import javax.swing.plaf.FontUIResource;

/**
 *
 * @author Benjamin A. Bartsch
 */
public class Gui extends javax.swing.JFrame {

    private final Data data = new Data();
    private final JFileChooser fcOpenSave = new JFileChooser();
    private final JFileChooser fcSolver = new JFileChooser();
    private final JFileChooser fcOpenImport = new JFileChooser();
    private final JFileChooser fcOpenKurs42 = new JFileChooser();
    private final JFileChooser fcOpenKurs42xml = new JFileChooser();

    /**
     * Creates new form MainFrame
     */
    public Gui() {
        initComponents();
        set_schrift_groesse(1.0);

        // Konfiguration
        fcOpenSave.setFileSelectionMode(JFileChooser.FILES_ONLY);
        fcSolver.setFileSelectionMode(JFileChooser.FILES_ONLY);
        fcOpenImport.setFileSelectionMode(JFileChooser.FILES_ONLY);
        fcOpenKurs42.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fcOpenKurs42xml.setFileSelectionMode(JFileChooser.FILES_ONLY);

        // unsichtbar machen
        jPanel7.setVisible(false);
        jPanel129.setVisible(false);
        jPanel25.setVisible(false);
        regelB_panelA.setVisible(false);
        regelB_panelB.setVisible(false);
        regelB_panelC.setVisible(false);
        regelB_panelD.setVisible(false);
        regelB_panelE.setVisible(false);
        regelB_buttonAdd.setVisible(false);

        // Zentrieren und relativ zum Bildschirm skalieren (75%)
        Dimension dim1 = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension dim2 = new Dimension((int) (dim1.width * 0.75), (int) (dim1.height * 0.75));
        setSize(dim2);
        int x = (int) ((dim1.getWidth() - this.getWidth()) / 2);
        int y = (int) ((dim1.getHeight() - this.getHeight()) / 2);
        this.setLocation(x, y);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        panelError = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        textAreaError = new javax.swing.JTextArea();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        faPanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jPanel109 = new javax.swing.JPanel();
        jPanel110 = new javax.swing.JPanel();
        jPanel117 = new javax.swing.JPanel();
        jButton15 = new javax.swing.JButton();
        jButton16 = new javax.swing.JButton();
        jPanel118 = new javax.swing.JPanel();
        jScrollPane18 = new javax.swing.JScrollPane();
        listFa = new javax.swing.JList<>();
        jPanel129 = new javax.swing.JPanel();
        jPanel130 = new javax.swing.JPanel();
        jPanel138 = new javax.swing.JPanel();
        jTextField36 = new javax.swing.JTextField();
        jPanel5 = new javax.swing.JPanel();
        jPanel132 = new javax.swing.JPanel();
        jTextField31 = new javax.swing.JTextField();
        jPanel133 = new javax.swing.JPanel();
        jTextField32 = new javax.swing.JTextField();
        jPanel7 = new javax.swing.JPanel();
        bePanelB = new javax.swing.JPanel();
        jPanelV1 = new javax.swing.JPanel();
        jPanel94 = new javax.swing.JPanel();
        jButton13 = new javax.swing.JButton();
        jTextField2 = new javax.swing.JTextField();
        jPanelV2 = new javax.swing.JPanel();
        jPanelV3 = new javax.swing.JPanel();
        jPanel99 = new javax.swing.JPanel();
        jPanel18 = new javax.swing.JPanel();
        jPanel22 = new javax.swing.JPanel();
        jPanel14 = new javax.swing.JPanel();
        jPanel13 = new javax.swing.JPanel();
        jPanelV4 = new javax.swing.JPanel();
        jPanelV5 = new javax.swing.JPanel();
        jPanel20 = new javax.swing.JPanel();
        jPanel21 = new javax.swing.JPanel();
        jPanel19 = new javax.swing.JPanel();
        regel_select = new javax.swing.JComboBox<>();
        jButton1 = new javax.swing.JButton();
        jPanel27 = new javax.swing.JPanel();
        regelB_panelA = new javax.swing.JPanel();
        regel_comboboxA = new javax.swing.JComboBox<>();
        jPanel31 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        regelB_panelB = new javax.swing.JPanel();
        regel_comboboxB = new javax.swing.JComboBox<>();
        jPanel32 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        regelB_panelC = new javax.swing.JPanel();
        regel_comboboxC = new javax.swing.JComboBox<>();
        jPanel33 = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        regelB_panelD = new javax.swing.JPanel();
        regel_comboboxD = new javax.swing.JComboBox<>();
        jPanel35 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        regelB_panelE = new javax.swing.JPanel();
        regel_comboboxE = new javax.swing.JComboBox<>();
        jPanel36 = new javax.swing.JPanel();
        jLabel14 = new javax.swing.JLabel();
        regelB_buttonAdd = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        regel_text = new javax.swing.JTextArea();
        jPanel28 = new javax.swing.JPanel();
        jPanel23 = new javax.swing.JPanel();
        jPanel144 = new javax.swing.JPanel();
        jPanel145 = new javax.swing.JPanel();
        jPanel146 = new javax.swing.JPanel();
        jButton25 = new javax.swing.JButton();
        jButton27 = new javax.swing.JButton();
        jPanel147 = new javax.swing.JPanel();
        jScrollPane24 = new javax.swing.JScrollPane();
        listBeB = new javax.swing.JList<>();
        jPanel158 = new javax.swing.JPanel();
        jPanel159 = new javax.swing.JPanel();
        jPanel160 = new javax.swing.JPanel();
        jButton28 = new javax.swing.JButton();
        jPanel161 = new javax.swing.JPanel();
        jScrollPane25 = new javax.swing.JScrollPane();
        listErB = new javax.swing.JList<>();
        jPanel25 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem9 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenuItem10 = new javax.swing.JMenuItem();
        jMenuItem11 = new javax.swing.JMenuItem();
        jMenuItem12 = new javax.swing.JMenuItem();
        jMenuItem13 = new javax.swing.JMenuItem();

        panelError.setLayout(new java.awt.BorderLayout());

        textAreaError.setColumns(20);
        textAreaError.setRows(5);
        jScrollPane1.setViewportView(textAreaError);

        panelError.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(Static.TITLE);
        setMinimumSize(new java.awt.Dimension(1000, 600));

        jTabbedPane1.setFont(Static.FONT_TABS);
        jTabbedPane1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jTabbedPane1StateChanged(evt);
            }
        });

        faPanel.setLayout(new java.awt.GridLayout(1, 0));

        jPanel4.setLayout(new java.awt.GridLayout(1, 2));

        jPanel109.setLayout(new java.awt.GridLayout(0, 1));

        jPanel110.setBorder(javax.swing.BorderFactory.createTitledBorder("Liste"));
        jPanel110.setLayout(new java.awt.BorderLayout());

        java.awt.FlowLayout flowLayout2 = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flowLayout2.setAlignOnBaseline(true);
        jPanel117.setLayout(flowLayout2);

        jButton15.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        jButton15.setText("+");
        jButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton15ActionPerformed(evt);
            }
        });
        jPanel117.add(jButton15);

        jButton16.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        jButton16.setText("-");
        jButton16.setEnabled(false);
        jButton16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton16ActionPerformed(evt);
            }
        });
        jPanel117.add(jButton16);

        jPanel110.add(jPanel117, java.awt.BorderLayout.NORTH);

        jPanel118.setLayout(new java.awt.BorderLayout());

        listFa.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        listFa.setModel(data.fa_list_model);
        listFa.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                listFaKeyPressed(evt);
            }
        });
        listFa.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                listFaValueChanged(evt);
            }
        });
        jScrollPane18.setViewportView(listFa);

        jPanel118.add(jScrollPane18, java.awt.BorderLayout.CENTER);

        jPanel110.add(jPanel118, java.awt.BorderLayout.CENTER);

        jPanel109.add(jPanel110);

        jPanel4.add(jPanel109);

        jPanel129.setBorder(javax.swing.BorderFactory.createTitledBorder("Attribute"));
        jPanel129.setLayout(new java.awt.BorderLayout());

        jPanel130.setLayout(new java.awt.GridLayout(0, 1));

        jPanel138.setBorder(javax.swing.BorderFactory.createTitledBorder("ID"));
        jPanel138.setLayout(new java.awt.BorderLayout());

        jTextField36.setEditable(false);
        jTextField36.setBackground(Static.COLOR_NOT_EDITABLE);
        jTextField36.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField36KeyReleased(evt);
            }
        });
        jPanel138.add(jTextField36, java.awt.BorderLayout.CENTER);

        jPanel130.add(jPanel138);

        jPanel5.setLayout(new java.awt.GridLayout(1, 0));

        jPanel132.setBorder(javax.swing.BorderFactory.createTitledBorder("Kürzel"));
        jPanel132.setLayout(new java.awt.BorderLayout());

        jTextField31.setBackground(Static.COLOR_EDITABLE);
        jTextField31.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField31KeyReleased(evt);
            }
        });
        jPanel132.add(jTextField31, java.awt.BorderLayout.CENTER);

        jPanel5.add(jPanel132);

        jPanel130.add(jPanel5);

        jPanel133.setBorder(javax.swing.BorderFactory.createTitledBorder("Anzeigename"));
        jPanel133.setLayout(new java.awt.BorderLayout());

        jTextField32.setBackground(Static.COLOR_EDITABLE);
        jTextField32.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField32KeyReleased(evt);
            }
        });
        jPanel133.add(jTextField32, java.awt.BorderLayout.CENTER);

        jPanel130.add(jPanel133);

        jPanel129.add(jPanel130, java.awt.BorderLayout.NORTH);

        jPanel4.add(jPanel129);

        faPanel.add(jPanel4);

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        jPanel7.setLayout(new java.awt.GridLayout(1, 1));
        faPanel.add(jPanel7);

        jTabbedPane1.addTab("Fächer", faPanel);

        bePanelB.setLayout(new java.awt.GridLayout(1, 0));

        jPanelV1.setLayout(new java.awt.BorderLayout());

        jPanel94.setLayout(new java.awt.BorderLayout());

        jButton13.setText("Pfadauswahl: CryptMiniSat");
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });
        jPanel94.add(jButton13, java.awt.BorderLayout.WEST);

        jTextField2.setBackground(Static.COLOR_EDITABLE);
        jTextField2.setColumns(15);
        jTextField2.setText(Static.get_path_crypto());
        jTextField2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField2KeyReleased(evt);
            }
        });
        jPanel94.add(jTextField2, java.awt.BorderLayout.CENTER);

        jPanelV1.add(jPanel94, java.awt.BorderLayout.NORTH);

        jPanelV2.setLayout(new java.awt.BorderLayout());

        jPanelV3.setLayout(new java.awt.BorderLayout());

        jPanel99.setLayout(new java.awt.GridLayout(1, 0));
        jPanel99.add(jPanel18);
        jPanel99.add(jPanel22);
        jPanel99.add(jPanel14);
        jPanel99.add(jPanel13);

        jPanelV3.add(jPanel99, java.awt.BorderLayout.NORTH);

        jPanelV4.setLayout(new java.awt.BorderLayout());

        jPanelV5.setLayout(new java.awt.BorderLayout());

        jPanel20.setBorder(javax.swing.BorderFactory.createTitledBorder("Regeln"));
        jPanel20.setLayout(new java.awt.BorderLayout());

        jPanel21.setLayout(new java.awt.GridLayout(0, 1));

        jPanel19.setLayout(new java.awt.BorderLayout());

        regel_select.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        regel_select.setMaximumRowCount(24);
        regel_select.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0#Bitte wählen Sie eine Regel aus...", "100#Fach<A> hat in der Sek.<B> in der Summe<C> Unterrichtsstunden.", "101#Fach<A> in der Stufe<B> ist <C>-stündig.", "102#Fach<A> in der Sek.<B> niemals <C>-stündig.", "103#Stufe<A> hat zwischen <B> und <C> Wochenstunden.", "104#Stufe<A> gleichbehandlung der Fächer <B>, <C>, <D>.", " ", " " }));
        regel_select.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                regel_selectActionPerformed(evt);
            }
        });
        jPanel19.add(regel_select, java.awt.BorderLayout.CENTER);

        jButton1.setText("Hilfe");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel19.add(jButton1, java.awt.BorderLayout.EAST);

        jPanel21.add(jPanel19);

        jPanel27.setLayout(new java.awt.GridLayout(1, 0, 10, 0));

        regelB_panelA.setLayout(new java.awt.BorderLayout());

        regel_comboboxA.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        regel_comboboxA.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        regelB_panelA.add(regel_comboboxA, java.awt.BorderLayout.CENTER);

        jPanel31.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel10.setText("<A>");
        jLabel10.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jPanel31.add(jLabel10);

        regelB_panelA.add(jPanel31, java.awt.BorderLayout.NORTH);

        jPanel27.add(regelB_panelA);

        regelB_panelB.setLayout(new java.awt.BorderLayout());

        regel_comboboxB.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        regel_comboboxB.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        regelB_panelB.add(regel_comboboxB, java.awt.BorderLayout.CENTER);

        jPanel32.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel11.setText("<B>");
        jLabel11.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jPanel32.add(jLabel11);

        regelB_panelB.add(jPanel32, java.awt.BorderLayout.NORTH);

        jPanel27.add(regelB_panelB);

        regelB_panelC.setLayout(new java.awt.BorderLayout());

        regel_comboboxC.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        regel_comboboxC.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        regelB_panelC.add(regel_comboboxC, java.awt.BorderLayout.CENTER);

        jPanel33.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel12.setText("<C>");
        jPanel33.add(jLabel12);

        regelB_panelC.add(jPanel33, java.awt.BorderLayout.NORTH);

        jPanel27.add(regelB_panelC);

        regelB_panelD.setLayout(new java.awt.BorderLayout());

        regel_comboboxD.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        regel_comboboxD.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        regelB_panelD.add(regel_comboboxD, java.awt.BorderLayout.CENTER);

        jPanel35.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel13.setText("<D>");
        jPanel35.add(jLabel13);

        regelB_panelD.add(jPanel35, java.awt.BorderLayout.NORTH);

        jPanel27.add(regelB_panelD);

        regelB_panelE.setLayout(new java.awt.BorderLayout());

        regel_comboboxE.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        regel_comboboxE.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        regelB_panelE.add(regel_comboboxE, java.awt.BorderLayout.CENTER);

        jPanel36.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel14.setText("<E>");
        jPanel36.add(jLabel14);

        regelB_panelE.add(jPanel36, java.awt.BorderLayout.NORTH);

        jPanel27.add(regelB_panelE);

        regelB_buttonAdd.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        regelB_buttonAdd.setText("↓");
        regelB_buttonAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                regelB_buttonAddActionPerformed(evt);
            }
        });
        jPanel27.add(regelB_buttonAdd);

        jPanel21.add(jPanel27);

        jPanel20.add(jPanel21, java.awt.BorderLayout.NORTH);

        regel_text.setColumns(20);
        regel_text.setRows(5);
        regel_text.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                regel_textKeyTyped(evt);
            }
            public void keyReleased(java.awt.event.KeyEvent evt) {
                regel_textKeyReleased(evt);
            }
        });
        jScrollPane3.setViewportView(regel_text);

        jPanel20.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        jPanelV5.add(jPanel20, java.awt.BorderLayout.CENTER);

        jPanelV4.add(jPanelV5, java.awt.BorderLayout.CENTER);

        jPanelV3.add(jPanelV4, java.awt.BorderLayout.CENTER);

        jPanelV2.add(jPanelV3, java.awt.BorderLayout.CENTER);

        jPanelV1.add(jPanelV2, java.awt.BorderLayout.CENTER);

        bePanelB.add(jPanelV1);

        jPanel28.setLayout(new java.awt.BorderLayout());

        jPanel23.setLayout(new java.awt.GridLayout(1, 2));

        jPanel144.setLayout(new java.awt.GridLayout(0, 1));

        jPanel145.setBorder(javax.swing.BorderFactory.createTitledBorder("Liste laufender Berechnungen"));
        jPanel145.setLayout(new java.awt.BorderLayout());

        java.awt.FlowLayout flowLayout4 = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flowLayout4.setAlignOnBaseline(true);
        jPanel146.setLayout(flowLayout4);

        jButton25.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        jButton25.setText("+");
        jButton25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton25ActionPerformed(evt);
            }
        });
        jPanel146.add(jButton25);

        jButton27.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        jButton27.setText("-");
        jButton27.setEnabled(false);
        jButton27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton27ActionPerformed(evt);
            }
        });
        jPanel146.add(jButton27);

        jPanel145.add(jPanel146, java.awt.BorderLayout.NORTH);

        jPanel147.setLayout(new java.awt.BorderLayout());

        listBeB.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        listBeB.setModel(data.beB_list_model);
        listBeB.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        listBeB.setVisibleRowCount(6);
        listBeB.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                listBeBKeyPressed(evt);
            }
        });
        listBeB.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                listBeBValueChanged(evt);
            }
        });
        jScrollPane24.setViewportView(listBeB);

        jPanel147.add(jScrollPane24, java.awt.BorderLayout.CENTER);

        jPanel145.add(jPanel147, java.awt.BorderLayout.CENTER);

        jPanel144.add(jPanel145);

        jPanel23.add(jPanel144);

        jPanel158.setLayout(new java.awt.GridLayout(0, 1));

        jPanel159.setBorder(javax.swing.BorderFactory.createTitledBorder("Liste der Ergebnisse"));
        jPanel159.setLayout(new java.awt.BorderLayout());

        java.awt.FlowLayout flowLayout5 = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flowLayout5.setAlignOnBaseline(true);
        jPanel160.setLayout(flowLayout5);

        jButton28.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        jButton28.setText("-");
        jButton28.setEnabled(false);
        jButton28.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton28ActionPerformed(evt);
            }
        });
        jPanel160.add(jButton28);

        jPanel159.add(jPanel160, java.awt.BorderLayout.NORTH);

        jPanel161.setLayout(new java.awt.BorderLayout());

        listErB.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        listErB.setModel(data.erB_list_model);
        listErB.setVisibleRowCount(6);
        listErB.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                listErBKeyPressed(evt);
            }
        });
        listErB.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                listErBValueChanged(evt);
            }
        });
        jScrollPane25.setViewportView(listErB);

        jPanel161.add(jScrollPane25, java.awt.BorderLayout.CENTER);

        jPanel159.add(jPanel161, java.awt.BorderLayout.CENTER);

        jPanel158.add(jPanel159);

        jPanel23.add(jPanel158);

        jPanel28.add(jPanel23, java.awt.BorderLayout.NORTH);

        jPanel25.setBorder(javax.swing.BorderFactory.createTitledBorder("Ergebnis im Detail"));
        jPanel25.setLayout(new java.awt.BorderLayout());

        jScrollPane4.setBorder(null);

        jTextPane1.setContentType("text/html"); // NOI18N
        jTextPane1.setFont(new java.awt.Font("DialogInput", 0, 11)); // NOI18N
        jScrollPane4.setViewportView(jTextPane1);

        jPanel25.add(jScrollPane4, java.awt.BorderLayout.CENTER);

        jPanel28.add(jPanel25, java.awt.BorderLayout.CENTER);

        bePanelB.add(jPanel28);

        jTabbedPane1.addTab("Berechnungen", bePanelB);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        jMenu1.setText("Datei");

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setText("Öffnen ...");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem2.setText("Speichern unter ...");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem2);

        jMenuBar1.add(jMenu1);

        jMenu3.setText("Schriftgröße");
        jMenu3.setFont(Static.FONT_DEFAULT);

        jMenuItem8.setFont(Static.FONT_DEFAULT);
        jMenuItem8.setText("Faktor 0.7");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem8);

        jMenuItem9.setFont(Static.FONT_DEFAULT);
        jMenuItem9.setText("Faktor 0.85");
        jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem9ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem9);

        jMenuItem6.setFont(Static.FONT_DEFAULT);
        jMenuItem6.setText("Faktor 1.0");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem6);

        jMenuItem7.setFont(Static.FONT_DEFAULT);
        jMenuItem7.setText("Faktor 1.1");
        jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem7ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem7);

        jMenuItem10.setFont(Static.FONT_DEFAULT);
        jMenuItem10.setText("Faktor 1.2");
        jMenuItem10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem10ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem10);

        jMenuItem11.setFont(Static.FONT_DEFAULT);
        jMenuItem11.setText("Faktor 1.3");
        jMenuItem11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem11ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem11);

        jMenuItem12.setFont(Static.FONT_DEFAULT);
        jMenuItem12.setText("Faktor 1.4");
        jMenuItem12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem12ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem12);

        jMenuItem13.setFont(Static.FONT_DEFAULT);
        jMenuItem13.setText("Faktor 1.5");
        jMenuItem13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem13ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem13);

        jMenuBar1.add(jMenu3);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        // Speichern...

        try {
            String standardPfad = Static.getStandardPfadSpeichern();
            fcOpenSave.setCurrentDirectory(new File(standardPfad));
        } catch (Exception ex) {
            handleException(ex);
        }

        int result = fcOpenSave.showSaveDialog(rootPane);

        if (result != JFileChooser.APPROVE_OPTION) {
            return;
        }

        File file = fcOpenSave.getSelectedFile();
        if (file.exists()) {
            int result2 = JOptionPane.showConfirmDialog(rootPane, "Überschreiben?", "Speichern...", JOptionPane.OK_CANCEL_OPTION);
            if (result2 != JOptionPane.OK_OPTION) {
                return;
            }
        }

        try {
            try (ObjectOutputStream oos = new ObjectOutputStream(new GZIPOutputStream(new FileOutputStream(file)))) {
                data.misc_save(oos);
            }
            Static.setStandardPfadSpeichern(file.getParentFile().getAbsolutePath());
        } catch (IOException ex) {
            handleException(ex);
        }

        revalidate();
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        // Öffnen
        try {
            String standardPfad = Static.getStandardPfadSpeichern();
            fcOpenSave.setCurrentDirectory(new File(standardPfad));
        } catch (Exception ex) {
            handleException(ex);
        }

        try {
            int result = fcOpenSave.showOpenDialog(rootPane);

            if (result != JFileChooser.APPROVE_OPTION) {
                return;
            }

            File file = fcOpenSave.getSelectedFile();
            if (!file.exists()) {
                JOptionPane.showMessageDialog(rootPane, "Datei nicht gefunden: " + file);
                return;
            }

            clear_all_selections();

            try (ObjectInputStream ois = new ObjectInputStream(new GZIPInputStream(new FileInputStream(file)))) {
                data.misc_open(ois);
            }

            Static.setStandardPfadSpeichern(file.getParentFile().getAbsolutePath());
        } catch (Exception ex) {
            handleException(ex);
        }

        revalidate();
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
        set_schrift_groesse(0.7);
    }//GEN-LAST:event_jMenuItem8ActionPerformed

    private void jMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem9ActionPerformed
        set_schrift_groesse(0.85);
    }//GEN-LAST:event_jMenuItem9ActionPerformed

    private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
        set_schrift_groesse(1.0);
    }//GEN-LAST:event_jMenuItem6ActionPerformed

    private void jMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem7ActionPerformed
        set_schrift_groesse(1.1);
    }//GEN-LAST:event_jMenuItem7ActionPerformed

    private void jMenuItem10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem10ActionPerformed
        set_schrift_groesse(1.2);
    }//GEN-LAST:event_jMenuItem10ActionPerformed

    private void jMenuItem11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem11ActionPerformed
        set_schrift_groesse(1.3);
    }//GEN-LAST:event_jMenuItem11ActionPerformed

    private void jMenuItem12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem12ActionPerformed
        set_schrift_groesse(1.4);
    }//GEN-LAST:event_jMenuItem12ActionPerformed

    private void jMenuItem13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem13ActionPerformed
        set_schrift_groesse(1.5);
    }//GEN-LAST:event_jMenuItem13ActionPerformed

    private void jTabbedPane1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jTabbedPane1StateChanged
        // TAB changed

        D_Fach fa = listFa.getSelectedValue();
        if (fa != null) {
            listFa.clearSelection();
            listFa.setSelectedValue(fa, true);
        }

        D_Ergebnis erb = listErB.getSelectedValue();
        if (erb != null) {
            listErB.clearSelection();
            listErB.setSelectedValue(erb, true);
        }
    }//GEN-LAST:event_jTabbedPane1StateChanged

    private void listErBValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_listErBValueChanged
        // # listErB
        D_Ergebnis er = listErB.getSelectedValue();

        jPanel25.setVisible(er != null);
        jButton28.setEnabled(er != null);

        jTextPane1.setText("");

        if (er == null) {
            return;
        }

        // Laden der Daten
        jTextPane1.setText(er.data);
        jTextPane1.setCaretPosition(0);
    }//GEN-LAST:event_listErBValueChanged

    private void listErBKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_listErBKeyPressed
        if (evt.getKeyCode() == KeyEvent.VK_DELETE) {
            jButton28ActionPerformed(null);
        }
    }//GEN-LAST:event_listErBKeyPressed

    private void jButton28ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton28ActionPerformed
        // - ER_B

        int result = JOptionPane.showConfirmDialog(
                rootPane,
                "Wollen Sie " + listErB.getSelectedValuesList() + " wirklich löschen?",
                "Löschen von Resultaten",
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE
        );
        if (result != JOptionPane.OK_OPTION) {
            return;
        }

        for (D_Ergebnis er : listErB.getSelectedValuesList()) {
            data.erB_del(er);
        }

        listErB.clearSelection();
        revalidate();
    }//GEN-LAST:event_jButton28ActionPerformed

    private void listBeBValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_listBeBValueChanged
        // # Kl
        D_Berechnung beb = listBeB.getSelectedValue();

        jButton27.setEnabled(beb != null);

        if (beb == null) {
            return;
        }

        this.revalidate();
    }//GEN-LAST:event_listBeBValueChanged

    private void listBeBKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_listBeBKeyPressed
        if (evt.getKeyCode() == KeyEvent.VK_DELETE) {
            jButton27ActionPerformed(null);
        }
    }//GEN-LAST:event_listBeBKeyPressed

    private void jButton27ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton27ActionPerformed
        // - BeB
        int result = JOptionPane.showConfirmDialog(
                rootPane,
                "Wollen Sie wirklich die Berechnungen " + listBeB.getSelectedValuesList() + " abbrechen?",
                "Abbruch einer Berechnung",
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE
        );
        if (result != JOptionPane.OK_OPTION) {
            return;
        }

        for (D_Berechnung beb : listBeB.getSelectedValuesList()) {
            data.beB_del(beb.beID);
        }

        listBeB.clearSelection();
        revalidate();
    }//GEN-LAST:event_jButton27ActionPerformed

    private void jButton25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton25ActionPerformed
        // + Berechnung_B
        try {
            synchronized (data) {
                D_Berechnung beb = data.beB_create();
                listBeB.clearSelection();
                listBeB.setSelectedValue(beb, true);
            }
            revalidate();
        } catch (Exception ex) {
            handleException(ex);
        }
    }//GEN-LAST:event_jButton25ActionPerformed

    private void regel_textKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_regel_textKeyReleased
        // Regeln_B
        String regelB = regel_text.getText();
        data.co_set_regeln(regelB);
        // revalidate(); darf man nicht, sonst kann man nichts tippen
    }//GEN-LAST:event_regel_textKeyReleased

    private void regelB_buttonAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_regelB_buttonAddActionPerformed
        try {
            String s = (String) regel_select.getSelectedItem();

            if (regelB_panelA.isVisible()) {
                s = Static.replace(s, 1, "" + regel_comboboxA.getSelectedItem());
            }
            if (regelB_panelB.isVisible()) {
                s = Static.replace(s, 2, "" + regel_comboboxB.getSelectedItem());
            }
            if (regelB_panelC.isVisible()) {
                s = Static.replace(s, 3, "" + regel_comboboxC.getSelectedItem());
            }
            if (regelB_panelD.isVisible()) {
                s = Static.replace(s, 4, "" + regel_comboboxD.getSelectedItem());
            }
            if (regelB_panelE.isVisible()) {
                s = Static.replace(s, 5, "" + regel_comboboxE.getSelectedItem());
            }

            regel_text.append(s + "\n");
            regel_select.setSelectedIndex(0);

            data.co_set_regeln(regel_text.getText());
            revalidate();
        } catch (InternalException | UserException ex) {
            handleException(ex);
        }
    }//GEN-LAST:event_regelB_buttonAddActionPerformed

    private void regel_selectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_regel_selectActionPerformed
        try {
            regelB_panelA.setVisible(false);
            regelB_panelB.setVisible(false);
            regelB_panelC.setVisible(false);
            regelB_panelD.setVisible(false);
            regelB_panelE.setVisible(false);
            regelB_buttonAdd.setVisible(false);

            String line = (String) regel_select.getSelectedItem();
            if (line == null) {
                return;
            }

            String[] split = line.split("\\#");
            if (split[0].trim().isEmpty()) {
                return;
            }

            int nr = Integer.parseInt(split[0]);

            regelB_buttonAdd.setVisible(nr != 0);
            regelB_panelA.setVisible(line.contains("<A>"));
            regelB_panelB.setVisible(line.contains("<B>"));
            regelB_panelC.setVisible(line.contains("<C>"));
            regelB_panelD.setVisible(line.contains("<D>"));
            regelB_panelE.setVisible(line.contains("<E>"));

            switch (nr) {
                case 0:
                    break;
                case 100: // 100#Fach<A> hat in der Sek.<B> in der Summe<C> Unterrichtsstunden.
                    load_faecher(regel_comboboxA, false);
                    load_zahlenliste(regel_comboboxB, 1, 2, true);
                    load_zahlenliste(regel_comboboxC, 1, 99, false);
                    break;
                case 101: // 101#Fach<A> in der Stufe<B> ist <C>-stündig.
                    load_faecher(regel_comboboxA, false);
                    load_zahlenliste(regel_comboboxB, 5, 10, false);
                    load_zahlenliste(regel_comboboxC, 0, 5, false);
                    break;
                case 102: // 102#Fach<A> in der Sek.<B> niemals <C>-stündig.
                    load_faecher(regel_comboboxA, false);
                    load_zahlenliste(regel_comboboxB, 1, 2, true);
                    load_zahlenliste(regel_comboboxC, 0, 5, false);
                    break;
                case 103: // 103#Stufe<A> hat zwischen <B> und <C> Wochenstunden.
                    load_zahlenliste(regel_comboboxA, 5, 10, false);
                    load_zahlenliste(regel_comboboxB, 25, 35, false);
                    load_zahlenliste(regel_comboboxC, 25, 35, false);
                    break;
                case 104: // 104#Stufe<A> gleichbehandlung der Fächer <B>, <C>, <D>.
                    load_zahlenliste(regel_comboboxA, 5, 10, false);
                    load_faecher(regel_comboboxB, false);
                    load_faecher(regel_comboboxC, false);
                    load_faecher(regel_comboboxD, true);
                    break;
                default:
                    throw new UserException("Die Regel mit Nummer " + nr + " ist unbekannt!");
            }
        } catch (Exception ex) {
            handleException(ex);
        }
    }//GEN-LAST:event_regel_selectActionPerformed

    private void jTextField2KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField2KeyReleased
        Static.set_path_crypto(jTextField2.getText());
    }//GEN-LAST:event_jTextField2KeyReleased

    private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton13ActionPerformed
        try {
            int result = fcSolver.showOpenDialog(this);
            if (result != JFileChooser.APPROVE_OPTION) {
                return;
            }
            File file = fcSolver.getSelectedFile();
            if (file == null) {
                return;
            }
            if (file.isDirectory()) {
                return;
            }
            if (!file.exists()) {
                return;
            }
            jTextField2.setText(file.getAbsolutePath());
            Static.set_path_crypto(file.getAbsolutePath());
            revalidate();
        } catch (HeadlessException ex) {
            handleException(ex);
        }
    }//GEN-LAST:event_jButton13ActionPerformed

    private void jTextField32KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField32KeyReleased
        // Le - Name
        try {
            D_Fach fa = listFa.getSelectedValue();

            if (fa == null) {
                return;
            }

            String name = jTextField32.getText();
            data.fa_single_set_name(fa.id, name);

            listFa.setSelectedValue(data.fa_get_from_array(fa.id), true);

            revalidate();
        } catch (InternalException ex) {
            handleException(ex);
        }
    }//GEN-LAST:event_jTextField32KeyReleased

    private void jTextField31KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField31KeyReleased
        // Fa - Kürzel
        try {
            D_Fach fa = listFa.getSelectedValue();

            if (fa == null) {
                return;
            }

            String newKuerzel = jTextField31.getText();
            jTextField31.setBackground(data.fa_valid_change_kuerzel(fa.id, newKuerzel) ? Static.COLOR_EDITABLE : Static.COLOR_ERROR);

            data.fa_single_set_kuerzel(fa.id, newKuerzel);
            listFa.setSelectedValue(data.fa_get_from_array(fa.id), true);

            revalidate();
        } catch (InternalException ex) {
            handleException(ex);
        }
    }//GEN-LAST:event_jTextField31KeyReleased

    private void jTextField36KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField36KeyReleased
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextField36KeyReleased

    private void listFaValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_listFaValueChanged
        D_Fach fa = listFa.getSelectedValue();

        jPanel129.setVisible(fa != null);
        //jPanel7.setVisible(fa != null);
        jButton16.setEnabled(fa != null);

        if (fa == null) {
            return;
        }

        // Laden der Daten
        jTextField36.setText(fa.id + "");
        jTextField31.setText(fa.kuerzel + "");
        jTextField32.setText(fa.name + "");

        // Laden des Plans (jPanel7)
        //jPanel7.removeAll();
        //jPanel7.revalidate();
        this.revalidate();
    }//GEN-LAST:event_listFaValueChanged

    private void listFaKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_listFaKeyPressed
        if (evt.getKeyCode() == KeyEvent.VK_DELETE) {
            jButton16ActionPerformed(null);
        }
    }//GEN-LAST:event_listFaKeyPressed

    private void jButton16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton16ActionPerformed
        // - Le
        int result = JOptionPane.showConfirmDialog(
                rootPane,
                "Wollen Sie das Fach " + listFa.getSelectedValuesList() + " wirklich löschen?",
                "Löschen eines Faches",
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE
        );
        if (result != JOptionPane.OK_OPTION) {
            return;
        }

        for (D_Fach fa : listFa.getSelectedValuesList()) {
            data.fa_del(fa);
        }

        listFa.clearSelection();
        revalidate();
    }//GEN-LAST:event_jButton16ActionPerformed

    private void jButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton15ActionPerformed
        try {
            String kuerzel = JOptionPane.showInputDialog(this, "Kürzel des Faches?");

            if (kuerzel == null) {
                return;
            }

            D_Fach fa = data.fa_create(kuerzel);

            listFa.clearSelection();
            listFa.setSelectedValue(fa, true);

            revalidate();
        } catch (Exception ex) {
            handleException(ex);
        }
    }//GEN-LAST:event_jButton15ActionPerformed

    private void regel_textKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_regel_textKeyTyped

    }//GEN-LAST:event_regel_textKeyTyped

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Button ?
        try {
            String line = (String) regel_select.getSelectedItem();
            int nr = Integer.parseInt(line.split("#")[0]);

            String text = "Hierfür gibt es leider noch keine Erklärung.";

            if (nr == 100) {
                text = "Setzt die Klausurlänge eines bestimmten Kurses <A> für die Klausur Nr. <C> auf die Klausurlänge <B>."
                        + "\nMündliche Klausuren sind davon nicht betroffen, da diese über den ganzen Tag gehen.";
            }
            if (nr == 101) {
                text = "Setzt die Klausurlänge eines bestimmten Kurses mit Fach/Kursart <A>/<B> für die Klausur Nr. <D> auf die Klausurlänge <C>."
                        + "\nMündliche Klausuren sind davon nicht betroffen, da diese über den ganzen Tag gehen.";
            }
            if (nr == 102) {
                text = "Setzt die Klausurlänge eines bestimmten Kurses der Schiene <A> für die Klausur Nr. <C> auf die Klausurlänge <B>."
                        + "\nMündliche Klausuren sind davon nicht betroffen, da diese über den ganzen Tag gehen.";
            }

            if (nr == 200) {
                text = "Sperrt das Datum<A> komplett. \nBeispielsweise aufgrund eines Feiertages."
                        + "\nSamstag und Sonntag sind immer gesperrt.";
            }
            if (nr == 201) {
                text = "Sperrt jedes Datum von <A> (inklusive) bis <B> (inklusive) komplett. \nBeispielsweise aufgrund von Ferien."
                        + "\nSamstag und Sonntag sind immer gesperrt.";
            }
            if (nr == 202) {
                text = "Sperrt für alle Klausuren die Stunden <A> (inklusive) bis <B> (inklusive) komplett."
                        + "\nSo kann man verhindern, dass beispielsweise ab Stunde 7 keine Klausuren liegen dürfen.";
            }
            if (nr == 203) {
                text = "Sperrt die Stunden <B> (inklusive) bis <C> (inklusive) an einem bestimmten Datum<A>."
                        + "\nSo kann man beispielsweise an einem bestimmten Datum Klausuren in bestimmten Stunden sperren.";
            }

            if (nr == 204) {
                text = "Gibt eine Obergrenze <A> an Klausuren pro Stundenplanzelle an. "
                        + "\nMündliche Prüfungen werden dabei ignoriert."
                        + "\nSo kann man erreichen, dass Unterricht gleichverteilt betroffen ist.";
            }
            if (nr == 205) {
                text = "Summiert pro Stundenplanzelle die Klausurtermine und forciert, "
                        + "\ndass höchsten <A> mal die Obergrenze von <B> (oder mehr) Klausuren pro Zelle überschritten wird."
                        + "\nMündliche Prüfungen werden dabei ignoriert."
                        + "\nZusammen mit Regel 204 kann man so noch ein wenig weiter optimieren.";
            }
            if (nr == 206) {
                text = "Gibt eine Obergrenze <C> an Klausuren für eine ganz bestimmte Stundenplanzelle an."
                        + "\nMündliche Prüfungen werden dabei ignoriert."
                        + "\nZusammen mit Regel 204 kann man so noch ein wenig weiter optimieren.";
            }

            if (nr == 250) {
                text = "Erzeugt für einen bestimmen Kurs <A> mehrere Klausuren. Die i-te Klausur gehört immer zur i-ten Klausurphase."
                        + "\nFalls ein Kurs weniger Klausuren schreibt, als es Klausurphasen gibt, "
                        + "\nso kann mit Regel 253 gezielt eine bestimmte Klausur ausfallen lassen.";
            }
            if (nr == 251) {
                text = "Erzeugt für Kurse mit Fach/Kursart <A>/<B> mehrere Klausuren. Die i-te Klausur gehört immer zur i-ten Klausurphase."
                        + "\nFalls ein Kurs weniger Klausuren schreibt, als es Klausurphasen gibt, "
                        + "\nso kann mit Regel 253 gezielt eine bestimmte Klausur ausfallen lassen.";
            }
            if (nr == 252) {
                text = "Lässt für einen bestimmten Kurs <A> die Klausur in der Klausurphase <B> ausfallen."
                        + "\nFalls ein Kurs weniger Klausuren schreibt, als es Klausurphasen gibt, "
                        + "\nso kann mit dieser Regel bestimmen, welche Klausur ausfallen soll.";
            }
            if (nr == 253) {
                text = "Lässt für bestimmte Kurse der Fach/Kursart <A>/<B> die Klausur in der Klausurphase <C> ausfallen."
                        + "\nFalls Kurse bestimmer Fach/Kursart weniger Klausuren schreiben, als es Klausurphasen gibt, "
                        + "\nso kann mit dieser Regel bestimmen, welche Klausur ausfallen soll.";
            }

            if (nr == 260) {
                text = "Betrachtet alle Klausuren des Kurses <A> und forciert, "
                        + "\ndass aufeinanderfolgende Klausuren mindestens <B> Tage voneinander entfernt sind."
                        + "\nHinweis: Könnte ggf. nicht funktionieren, wenn die mittlere von 3 Klausuren mit Regel 252/253 ausfällt."
                        + "\n...darüber muss ich noch nachdenken, wie man das lösen kann";
            }
            if (nr == 261) {
                text = "Betrachtet alle Klausuren des Kurse mit Fach/Kursart <A>/<B> und forciert, "
                        + "\ndass aufeinanderfolgende Klausuren mindestens <C> Tage voneinander entfernt sind."
                        + "\nHinweis: Könnte ggf. nicht funktionieren, wenn die mittlere von 3 Klausuren mit Regel 252/253 ausfällt."
                        + "\n...darüber muss ich noch nachdenken, wie man das lösen kann";
            }
            if (nr == 262) {
                text = "Betrachtet alle Klausuren der Schiene <A> und forciert, "
                        + "\ndass aufeinanderfolgende Klausuren mindestens <B> Tage voneinander entfernt sind."
                        + "\nHinweis: Könnte ggf. nicht funktionieren, wenn die mittlere von 3 Klausuren mit Regel 252/253 ausfällt."
                        + "\n...darüber muss ich noch nachdenken, wie man das lösen kann";
            }

            if (nr == 300) {
                text = "Betrachtet den/die Schüler/in <A> und verbietet <B=2..3> Klausurtage in Folge."
                        + "\nWürde man beispielsweise 2 Klausurtage in Folge verbieten, "
                        + "\nkönnten weiterhin drei Klausuren am Mo, Mi und Fr liegen.";
            }
            if (nr == 301) {
                text = "Zählt PRO Schülerin <A> wie oft <B=2..3> Klausurtage in Folge vorliegen und begrenzt dies auf maximal <C>."
                        + "\nBei beispielsweise <A>=* und <B>=2 und <C>=1 kann es bei JEDEM Schüler 1 mal vorkommen, "
                        + "\ndass 2 Klausuren an aufeinanderfolgenden Tagen stattfinden.";
            }
            if (nr == 302) {
                text = "Summiert über alle Schülerinnen wie oft <A=2..3> Klausurtage in Folge vorliegen und begrenzt dies auf maximal <B>."
                        + "\nBei beispielsweise <A>=2 und <B>=4 könnte es sein, dass bei 4 Schülern 2 Klausurtage in Folge vorliegen. "
                        + "\nEs kann aber auch sein, dass es 4 mal bei dem selben Schüler vorliegt. Oder jede andere mögliche Kombination.";
            }
            if (nr == 303) {
                text = "Forciert, dass ein Schüler <A> am Tag nach einer Klausur der Fach/Kursart <B>/<C> keine andere Klausur schreibt."
                        + "\nSo kann man z.B. verhindern, dass ein Schüler nach einer LK-Klausur eine andere Klausur schreibt.";
            }
            if (nr == 304) {
                text = "Forciert, dass ein Schüler <A> am Tag vor einer Klausur der Fach/Kursart <B>/<C> keine andere Klausur schreibt."
                        + "\nSo kann man z.B. verhindern, dass ein Schüler vor einer LK-Klausur eine andere Klausur schreibt.";
            }

            if (nr == 400) {
                text = "Forciert, dass alle Klausuren der Kurse gleicher Fach/Kursart pro Klausurphase gleichzeitig starten."
                        + "\nAusgenommen sind sämtliche Leistungskurse und mündliche Prüfungen."
                        + "\nAchtung: Schreibt ein Kurs 3 Klausuren und ein anderer 2, dann gilt diese Regel nur für die ersten 2 Klausuren.";
            }
            if (nr == 401) {
                text = "Forciert, dass alle Kurse der Schiene <A> in der Klausurphase <B> gleichzeitig starten."
                        + "\nFreiwilling ist die zusätzliche Fixierung eines Datums <C> und einer Stunde <D>."
                        + "\nAusgenommen sind sämtliche mündliche Prüfungen.";
            }
            if (nr == 402) {
                text = "Forciert, dass die Klausuren von Kurs <A> und Kurs <B> pro Klausurphase gleichzeitig starten."
                        + "\nAusgenommen sind sämtliche mündliche Prüfungen."
                        + "\nAchtung: Schreibt ein Kurs 3 Klausuren und ein anderer 2, dann gilt diese Regel nur für die ersten 2 Klausuren.";
            }
            if (nr == 403) {
                text = "Forciert, dass die Klausuren von Kurs <A> und die der Kurse mit Fach/Kursart <B>/<C> pro Klausurphase gleichzeitig starten."
                        + "\nAusgenommen sind sämtliche mündliche Prüfungen."
                        + "\nAchtung: Schreibt ein Kurs 3 Klausuren und ein anderer 2, dann gilt diese Regel nur für die ersten 2 Klausuren.";
            }
            if (nr == 404) {
                text = "Forciert, dass alle Klausuren der Fach/Kursart <A>/<B> pro Klausurphase gleichzeitig starten."
                        + "\nAusgenommen sind sämtliche mündliche Prüfungen."
                        + "\nAchtung: Schreibt ein Kurs 3 Klausuren und ein anderer 2, dann gilt diese Regel nur für die ersten 2 Klausuren.";
            }
            if (nr == 405) {
                text = "Forciert, dass alle Klausuren der Fach/Kursart <A>/<B> und Fach/Kursart <C>/<D> pro Klausurphase gleichzeitig starten."
                        + "\nAusgenommen sind sämtliche mündliche Prüfungen."
                        + "\nAchtung: Schreibt ein Kurs 3 Klausuren und ein anderer 2, dann gilt diese Regel nur für die ersten 2 Klausuren.";
            }
            if (nr == 406) {
                text = "Alle Klausuren aller Kurse, die zufälligerweise am gleichen Tag schreiben, müssen in der selben Stunde starten."
                        + "\nHinweis: Es werden dabei keine Kurse ignoriert!";
            }
            if (nr == 407) {
                text = "Alle Klausuren der selben Lehrkraft starten gemeinsam."
                        + "\nDies gilt pro Fach/Kursart und pro Klausurphase."
                        + "\nAusgenommen sind sämtliche mündliche Prüfungen.";
            }
            if (nr == 500) {
                text = "Verbietet den Beginn einer Klausur in einer bestimmten Stunde."
                        + "\nDies kann bei einem Doppelstundenmodell hilfreich sein, "
                        + "\nwenn z.B. der Beginn in den geraden Stunden verboten werden soll."
                        + "\nAusgenommen sind sämtliche mündliche Prüfungen.";
            }
            if (nr == 501) {
                text = "Verbietet den Beginn einer Klausur der Kursart <A> an einem bestimmten Wochentag<B> innerhalb eines Stundenintervalls."
                        + "\nHinweis: Es werden dabei keine Kurse ignoriert!";
            }
            if (nr == 502) {
                text = "Fixiert den Klausurbeginn eines ganz bestimmten Kurses (auch mündliche Prüfungen)."
                        + "\nHinweis: Die Angabe der konkreten Stunde ist freiwillig.";
            }
            if (nr == 503) {
                text = "Fixiert den Klausurbeginn einer ganz bestimmten Fach/Kursart <A>/<B> (auch mündliche Prüfungen)."
                        + "\nHinweis: Die Angabe der konkreten Stunde ist freiwillig.";
            }
            if (nr == 504) {
                text = "Grenzt für Klausuren des Kurses<A> das mögliche Datumsintervall ein (auch mündliche Prüfungen)."
                        + "\nHinweis: Es können auch alle Klausuren (*) ausgewählt werden.";
            }
            if (nr == 505) {
                text = "Grenzt für Klausuren der Kurs/Fachart <A>/<B> das mögliche Datumsintervall ein (auch mündliche Prüfungen)."
                        + "\nHinweis: Es können auch alle Klausuren (*) ausgewählt werden.";
            }
            if (nr == 601) {
                text = "Forciert, dass Leistungskurse nicht gleichzeitig mit anderen Kursen am selben Tag schreiben."
                        + "\nHinweis: Dies betriff auch mündliche Prüfungen.";
            }
            if (nr == 602) {
                text = "Limitiert die Anzahl aller Klausurtage auf maximal<A>"
                        + "\nHinweis: Dies betriff auch mündliche Prüfungen.";
            }
            if (nr == 603) {
                text = "Definiert eine bestimmte Klausur <C> eines Kurses<A> als mündliche Prüung, die über <B> Tage verläuft."
                        + "\nHinweis 1: Verläuft die Klausur über mehrere Tage, dann müssen diese aufeinanderfolgend in einer Woche Platz finden."
                        + "\nHinweis 2: Eine mündliche Klausur belegt alle Stunden des jeweiligen Tages."
                        + "\nHinweis 3: Theoretisch können auch andere Klausuren an diesem Tag stattfinden, falls die Schülerschnittmenge kollisionsfrei ist.";
            }
            if (nr == 604) {
                text = "Definiert eine bestimmte Klausur <C> einer Fach/Kursart <A>/<B> als mündliche Prüung, die über <B> Tage verläuft."
                        + "\nHinweis 1: Verläuft die Klausur über mehrere Tage, dann müssen diese aufeinanderfolgend in einer Woche Platz finden."
                        + "\nHinweis 2: Eine mündliche Klausur belegt alle Stunden des jeweiligen Tages."
                        + "\nHinweis 3: Theoretisch können auch andere Klausuren an diesem Tag stattfinden, falls die Schülerschnittmenge kollisionsfrei ist.";
            }
            if (nr == 605) {
                text = "Verhindert, dass Klausuren einer bestimmten Fach/Kursart <A>/<B> und einer anderen Fach/Kursart <C>/<D> in der gleichen Woche stattfinden.";
            }
            if (nr == 606) {
                text = "Begrenzt die Gesamtklausurenanzahl in einer Woche, wenn eine Klausur einer bestimmten Fach/Kursart <A>/<B> schreibt."
                        + "\nHinweis: Die Regel betrachtet nur die Kurse, auch wenn es einige SchülerInnen vielleicht gar nicht betrifft.";
            }
            if (nr == 607) {
                text = "Forciert, dass nach einer Klausur einer bestimmten Fach/Kursart <A>/<B> keine Klausur am Tag danach stattfindet."
                        + "\nHinweis: Die Regel gilt aus Kurs-Sicht, nicht aus Schüler-Sicht."
                        + "\nSie macht so keinen Sinn! -->  Nun abgelöst durch die Regel 303.";
            }
            if (nr == 608) {
                text = "Forciert, dass nach einer Klausur einer bestimmten Fach/Kursart <A>/<B> keine Klausur am Tag davor stattfindet."
                        + "\nHinweis: Die Regel gilt aus Kurs-Sicht, nicht aus Schüler-Sicht."
                        + "\nSie macht so keinen Sinn! -->  Nun abgelöst durch die Regel 304.";
            }
            if (nr == 609) {
                text = "Begrenzt die Anzahl <B> an Unterrichtsstunden bei denen mehr als ein gewisser Prozentsatz an SchülerInnen fehlt."
                        + "\nHinweis: Schreibt ein Schüler an dem Tag eine mündliche Klausur, zählt dieser als anwesend!";
            }
            if (nr == 610) {
                text = "Zählt über alle Unterrichtsstunden alle SchülerInnen, die aufrund einer anderen Klausur fehlen und begrenzt diese."
                        + "\nHinweis: Schreibt ein Schüler an dem Tag eine mündliche Klausur, zählt dieser als anwesend!";
            }
            if (nr == 600) {
                text = "Forciert, für die Fach/Kursart <A>/<B>, dass mindestens <C> Stunden im regulären Plan liegen."
                        + "\nHinweis: Mündliche Prüfungen werden nicht mitgezählt!";
            }
            if (nr == 611) {
                text = "Forciert, dass in der Summe über alle Kurse mindestens <A> Stunden im regulären Plan liegen."
                        + "\nHinweis: Mündliche Prüfungen werden nicht mitgezählt!";
            }

            JPanel panel = new JPanel(new GridLayout());
            JTextArea area = new JTextArea();
            panel.add(area);
            area.setText(text);
            set_font_recursive(new Component[]{panel});
            JOptionPane.showMessageDialog(this, panel, "Erklärung", JOptionPane.PLAIN_MESSAGE);
        } catch (Exception ex) {
            handleException(ex);
        }

    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Gui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Gui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Gui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Gui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Gui().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel bePanelB;
    private javax.swing.JPanel faPanel;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton16;
    private javax.swing.JButton jButton25;
    private javax.swing.JButton jButton27;
    private javax.swing.JButton jButton28;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem10;
    private javax.swing.JMenuItem jMenuItem11;
    private javax.swing.JMenuItem jMenuItem12;
    private javax.swing.JMenuItem jMenuItem13;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JPanel jPanel109;
    private javax.swing.JPanel jPanel110;
    private javax.swing.JPanel jPanel117;
    private javax.swing.JPanel jPanel118;
    private javax.swing.JPanel jPanel129;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel130;
    private javax.swing.JPanel jPanel132;
    private javax.swing.JPanel jPanel133;
    private javax.swing.JPanel jPanel138;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel144;
    private javax.swing.JPanel jPanel145;
    private javax.swing.JPanel jPanel146;
    private javax.swing.JPanel jPanel147;
    private javax.swing.JPanel jPanel158;
    private javax.swing.JPanel jPanel159;
    private javax.swing.JPanel jPanel160;
    private javax.swing.JPanel jPanel161;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel22;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel25;
    private javax.swing.JPanel jPanel27;
    private javax.swing.JPanel jPanel28;
    private javax.swing.JPanel jPanel31;
    private javax.swing.JPanel jPanel32;
    private javax.swing.JPanel jPanel33;
    private javax.swing.JPanel jPanel35;
    private javax.swing.JPanel jPanel36;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel94;
    private javax.swing.JPanel jPanel99;
    private javax.swing.JPanel jPanelV1;
    private javax.swing.JPanel jPanelV2;
    private javax.swing.JPanel jPanelV3;
    private javax.swing.JPanel jPanelV4;
    private javax.swing.JPanel jPanelV5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane18;
    private javax.swing.JScrollPane jScrollPane24;
    private javax.swing.JScrollPane jScrollPane25;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField31;
    private javax.swing.JTextField jTextField32;
    private javax.swing.JTextField jTextField36;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JList<stundentafel_cnf.D_Berechnung> listBeB;
    private javax.swing.JList<stundentafel_cnf.D_Ergebnis> listErB;
    private javax.swing.JList<D_Fach> listFa;
    private javax.swing.JPanel panelError;
    private javax.swing.JButton regelB_buttonAdd;
    private javax.swing.JPanel regelB_panelA;
    private javax.swing.JPanel regelB_panelB;
    private javax.swing.JPanel regelB_panelC;
    private javax.swing.JPanel regelB_panelD;
    private javax.swing.JPanel regelB_panelE;
    private javax.swing.JComboBox<String> regel_comboboxA;
    private javax.swing.JComboBox<String> regel_comboboxB;
    private javax.swing.JComboBox<String> regel_comboboxC;
    private javax.swing.JComboBox<String> regel_comboboxD;
    private javax.swing.JComboBox<String> regel_comboboxE;
    private javax.swing.JComboBox<String> regel_select;
    private javax.swing.JTextArea regel_text;
    private javax.swing.JTextArea textAreaError;
    // End of variables declaration//GEN-END:variables

    void handleException(Exception ex) {
        if (ex instanceof UserException) {
            UserException dex = (UserException) ex;
            JOptionPane.showMessageDialog(rootPane, dex.getMessage());
            return;
        }

        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        ex.printStackTrace(pw);

        String sError = "";
        sError += "Es ist ein Fehler passiert, der nicht passieren sollte.\n";
        sError += "Bitte senden Sie den folgenden Text an 'bar@gymnasium-eickel.herne.de':\n";
        sError += "\n";
        sError += "" + Static.TITLE + "\n";
        sError += "\n";
        sError += sw.toString();
        textAreaError.setText(sError);

        Rectangle r = Static.get_centered_rectangle();

        JDialog jd = new JDialog();
        jd.setTitle("Fehlermeldung");
        jd.setContentPane(panelError);
        jd.setBounds(r);
        jd.setModal(true);
        jd.setVisible(true);

        ex.printStackTrace();

    }

    private void clear_all_selections() {
        listFa.clearSelection();
        listErB.clearSelection();
        regel_select.setSelectedIndex(0);
    }

    @Override
    public void revalidate() {
        regel_text.setText(data.co_get_regeln());
        jTextField2.setText(Static.get_path_crypto());
        super.revalidate();
    }

    private void load_klausurlaengen(JComboBox<String> cb) {
        cb.removeAllItems();
        for (int laenge = 1; laenge <= 6; laenge++) {
            cb.addItem(laenge + "");
        }
    }

    private void load_faecher(JComboBox<String> cb, boolean mitStern) {
        cb.removeAllItems();
        if (mitStern) {
            cb.addItem("*");
        }
        for (String fach_kuerzel : data.fa_get_set()) {
            cb.addItem(fach_kuerzel + "");
        }
    }

    private void load_zahlenliste(JComboBox<String> cb, int min, int max, boolean mitStern) {
        cb.removeAllItems();
        if (mitStern) {
            cb.addItem("*");
        }
        for (int zahl = min; zahl <= max; zahl++) {
            cb.addItem(zahl + "");
        }
    }

    private void set_schrift_groesse(double factor) {
        //Static.FONT_FAKTOR = factor;

        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        int size1 = (int) ((d.height * factor) / 80);
        int size2 = (int) ((size1 * 3) / 4);
        Static.FONT_DEFAULT = new Font(Font.SANS_SERIF, Font.PLAIN, size1);
        Static.FONT_DEFAULT_SMALLER = new Font(Font.SANS_SERIF, Font.PLAIN, size2);
        Static.FONT_TITLED_BORDER = new Font(Font.SERIF, Font.BOLD, size2);
        Static.FONT_TEXT_AREA = new Font(Font.MONOSPACED, Font.PLAIN, size1);
        Static.FONT_CHECK_BOX = new Font(Font.SANS_SERIF, Font.PLAIN, size1);

        set_font_recursive(new Component[]{this, fcOpenImport, fcOpenSave, fcSolver, fcOpenKurs42});
        set_font_recursive(this.getComponents());

        revalidate();
        repaint();
    }

    private void set_font_recursive(Component[] comp) {
        for (int x = 0; x < comp.length; x++) {
            Component c = comp[x];

            try {
                c.setFont(Static.FONT_DEFAULT);
            } catch (Exception ex) {
                //do nothing
            }

            if (c instanceof Container) {
                set_font_recursive(((Container) c).getComponents());
            }

            if (c instanceof JCheckBox) {
                JCheckBox cb = (JCheckBox) c;
                cb.setFont(Static.FONT_CHECK_BOX);
            }

            if (c instanceof JTextArea) {
                JTextArea ta = (JTextArea) c;
                ta.setFont(Static.FONT_TEXT_AREA);
            }

            if (c instanceof JScrollPane) {
                JScrollPane scroll = (JScrollPane) c;
                if (scroll.getBorder() instanceof TitledBorder) {
                    TitledBorder tb = (TitledBorder) scroll.getBorder();
                    tb.setTitleFont(Static.FONT_DEFAULT_SMALLER);
                }
            }

            if (c instanceof JSpinner) {
                JSpinner spinner = (JSpinner) c;
                ((JSpinner.DefaultEditor) spinner.getEditor()).getTextField().setFont(Static.FONT_DEFAULT);
            }

            if (c instanceof JPanel) {
                JPanel panel = (JPanel) c;
                if (panel.getBorder() instanceof TitledBorder) {
                    TitledBorder tb = (TitledBorder) panel.getBorder();
                    tb.setTitleFont(Static.FONT_TITLED_BORDER);
                }
            }

            if (c instanceof JMenu) {
                JMenu menu = (JMenu) c;
                menu.setFont(new FontUIResource(Static.FONT_DEFAULT));
                set_font_recursive(menu.getMenuComponents());
            }

            if (c instanceof JButton) {
                JButton jb = (JButton) c;
                String text = jb.getText();
                if (text != null) {
                    /*if () {
                        jb.setFont(new FontUIResource(Static.FONT_DEFAULT_SMALLER));
                    }*/
                }
            }

        }
    }

}
